type tBlobReqPut = (source: machine, obj: tObject);
type tBlobResPut = (address: int, storageId: int);
event eBlobReqPut: tBlobReqPut;
event eBlobResPut: tBlobResPut;

type tBlobReqDel = (source: machine, address: int);
type tBlobResDel = (address: int);
event eBlobReqDel: tBlobReqDel;
event eBlobResDel: tBlobResDel;

type tBlobReqExists = (source: machine, address: int);
type tBlobResExists = (address: int, found: bool);
event eBlobReqExists: tBlobReqExists;
event eBlobResExists: tBlobResExists;

machine Blobstor
{
    var objects: map[int, tObject];

    start state Init {
        on eBlobReqPut do (r: tBlobReqPut) {
            if (!(r.obj.address in objects)) {
                objects += (r.obj.address, r.obj);
            }
            send r.source, eBlobResPut, (address = r.obj.address, storageId = 42);
        }

        on eBlobReqDel do (r: tBlobReqDel) {
            objects -= (r.address);
            send r.source, eBlobResDel, (address = r.address,);
        }

        on eBlobReqExists do (r: tBlobReqExists) {
            send r.source, eBlobResExists, (address = r.address, found = r.address in objects);
        }
    }
}
